//JSON结构化数据显示模块
var json_view = function (option, success) {
    var object = new JsonView(option);
    success();
    return object;
}

function JsonView(option) {
    this.markControl = option.markControl;
    this.init();
    this.markControl.on('step.board.show', this, function (event, context, eventObject) {
        this.container.removeClass('span12');
        this.container.addClass('span10');
    });
    this.markControl.on('step.board.hide', this, function (event, context, eventObject) {
        this.container.removeClass('span10');
        this.container.addClass('span12');
    });
    this.markControl.on('task.get.before', this, function (event, context, eventObject) {
        this.task = undefined;
        this.render();
    });
    this.markControl.on('task.get.success', this, function (event, context, eventObject) {
        this.task = context.task;
        this.render();
    });
    this.markControl.on('task.get.none', this, function (event, context, eventObject) {
        this.task = undefined;
        this.render();
    });
    this.markControl.on('mark.setting.init', this, function (event, context, setting) {
        var scale = setting['image.view.scale'];
        if (scale != undefined) {
            this.scale = Number(scale);
        }
    });
}

JsonView.prototype.init = function () {
    var self = this;
    this.container = this.markControl.container.imageContent;
    this.container.height(this.markControl.container.centerContent.height());
    this.container.css('overflow', 'scroll');
    this.container.addClass('rich-text');
}

JsonView.prototype.render = function () {
    this.container.empty();
    if (this.task != undefined && this.task.jsonData != undefined) {
    	var questionNumberArr = new Array();
    	for (var i in this.task.markStepList) {
            var step = this.task.markStepList[i];
            questionNumberArr[i] = step.questionNumber;
        }
    	
        let questions = this.task.jsonData || [];
        questions.forEach(question => {
            // 按题号过滤
        	if(questionNumberArr.indexOf(question.mainNumber+"."+question.subNumber) == -1){
 				return true; 
 			}
 		 	var questionTitle = '<span>题号：'+ question.mainNumber+'-'+question.subNumber +'<span><br/>';
 			$(questionTitle).appendTo($(this.container)); 
 			$("<span>题干：<span>"+renderRichText(question.body)).appendTo($(this.container));
        	$("<span>考生答案：<span>"+renderRichText(question.studentAnswer)).appendTo(this.container);
            $("<span>标准答案：<span>"+renderRichText(question.answer)).appendTo(this.container);
        });
        const viewer = new Viewer($('.image-content')[0], {
        });
        this.markControl.trigger('task.load.finish');
    }
}